package dev.pfaff.recipe_nope.mixin;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.narration.NarratableEntry;
import net.minecraft.client.gui.narration.NarrationElementOutput;
import net.minecraft.client.gui.screens.recipebook.RecipeBookComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.inventory.RecipeBookMenu;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;

import javax.annotation.Nullable;
import java.util.Iterator;
import java.util.List;

@Mixin(RecipeBookComponent.class)
public abstract class RecipeBookComponentMixin {
	@Shadow @Final private static Component ALL_RECIPES_TOOLTIP;
	@Shadow @Final private static Component ONLY_CRAFTABLES_TOOLTIP;

	@Overwrite
	public void init(int p_100310_, int p_100311_, Minecraft p_100312_, boolean p_100313_, RecipeBookMenu<?> p_100314_) {
	}

	@Overwrite
	public void initVisuals() {
	}

	@Overwrite
	public boolean changeFocus(boolean p_100372_) {
		return false;
	}

	@Overwrite
	protected void initFilterButtonTextures() {
	}

	@Overwrite
	public void removed() {
	}

	@Overwrite
	public int updateScreenPosition(int p_181402_, int p_181403_) {
		return (p_181402_ - p_181403_) / 2;
	}

	@Overwrite
	public void toggleVisibility() {
	}

	@Overwrite
	public boolean isVisible() {
		return false;
	}

	@Overwrite
	public boolean isVisibleAccordingToBookData() {
		return false;
	}

	@Overwrite
	protected void setVisible(boolean p_100370_) {
	}

	@Overwrite
	public void slotClicked(@Nullable Slot p_100315_) {
	}

	@Overwrite
	public void updateCollections(boolean p_100383_) {
	}

	@Overwrite
	public void updateTabs() {
	}

	@Overwrite
	public void tick() {
	}

	@Overwrite
	public void updateStackedContents() {
	}

	@Overwrite
	public void render(PoseStack p_100319_, int p_100320_, int p_100321_, float p_100322_) {
	}

	@Overwrite
	public void renderTooltip(PoseStack p_100362_, int p_100363_, int p_100364_, int p_100365_, int p_100366_) {
	}

	@Overwrite
	public Component getFilterButtonTooltip() {
		return ALL_RECIPES_TOOLTIP;
	}

	@Overwrite
	protected Component getRecipeFilterName() {
		return ONLY_CRAFTABLES_TOOLTIP;
	}

	@Overwrite
	public void renderGhostRecipeTooltip(PoseStack p_100375_, int p_100376_, int p_100377_, int p_100378_, int p_100379_) {
	}

	@Overwrite
	public void renderGhostRecipe(PoseStack p_100323_, int p_100324_, int p_100325_, boolean p_100326_, float p_100327_) {
	}

	@Overwrite
	public boolean mouseClicked(double p_100294_, double p_100295_, int p_100296_) {
		return false;
	}

	@Overwrite
	public boolean toggleFiltering() {
		return false;
	}

	@Overwrite
	public boolean hasClickedOutside(double p_100298_,
									 double p_100299_,
									 int p_100300_,
									 int p_100301_,
									 int p_100302_,
									 int p_100303_,
									 int p_100304_) {
		return true;
	}

	@Overwrite
	public boolean keyPressed(int p_100306_, int p_100307_, int p_100308_) {
		return false;
	}

	@Overwrite
	public boolean keyReleased(int p_100356_, int p_100357_, int p_100358_) {
		return false;
	}

	@Overwrite
	public boolean charTyped(char p_100291_, int p_100292_) {
		return false;
	}

	@Overwrite
	public boolean isMouseOver(double p_100353_, double p_100354_) {
		return false;
	}

	@Overwrite
	public void checkSearchStringUpdate() {
	}

	@Overwrite
	public void pirateSpeechForThePeople(String p_100336_) {
	}

	@Overwrite
	public boolean isOffsetNextToMainGUI() {
		return false;
	}

	@Overwrite
	public void recipesUpdated() {
	}

	@Overwrite
	public void recipesShown(List<Recipe<?>> p_100344_) {
	}

	@Overwrite
	public void setupGhostRecipe(Recipe<?> p_100316_, List<Slot> p_100317_) {
	}

	@Overwrite
	public void addItemToSlot(Iterator<Ingredient> p_100338_, int p_100339_, int p_100340_, int p_100341_, int p_100342_) {
	}

	@Overwrite
	protected void sendUpdateSettings() {
	}

	@Overwrite
	public NarratableEntry.NarrationPriority narrationPriority() {
		return NarratableEntry.NarrationPriority.NONE;
	}

	@Overwrite
	public void updateNarration(NarrationElementOutput p_170046_) {
	}
}
