package dev.pfaff.recipe_nope.mixin;

import dev.pfaff.recipe_nope.RecipeNope;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.network.protocol.game.ServerGamePacketListener;
import net.minecraft.network.protocol.game.ServerPacketListener;
import net.minecraft.network.protocol.game.ServerboundRecipeBookSeenRecipePacket;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Recipe;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.Redirect;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(ServerboundRecipeBookSeenRecipePacket.class)
public abstract class RecipeBookDataC2SPacketMixin {
	@Inject(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At("TAIL"))
	private void init$noRead(FriendlyByteBuf buf, CallbackInfo ci) {
		buf.readerIndex(buf.writerIndex());
	}

	@Redirect(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/network/FriendlyByteBuf;readResourceLocation()Lnet/minecraft/resources/ResourceLocation;"))
	private ResourceLocation init$noRead(FriendlyByteBuf instance) {
		return null;
	}

	@Overwrite
	public void write(FriendlyByteBuf buf) {
		throw RecipeNope.unsupported();
	}

	@Overwrite
	public void handle(ServerGamePacketListener serverPlayPacketListener) {
	}
}
