package dev.pfaff.recipe_nope.mixin;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.stats.RecipeBook;
import net.minecraft.stats.RecipeBookSettings;
import net.minecraft.world.inventory.RecipeBookMenu;
import net.minecraft.world.inventory.RecipeBookType;
import net.minecraft.world.item.crafting.Recipe;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;

import javax.annotation.Nullable;
import java.util.Set;

@Mixin(RecipeBook.class)
public abstract class RecipeBookMixin {
	@Shadow @Final private RecipeBookSettings bookSettings;

	@Overwrite
	public void copyOverData(RecipeBook p_12686_) {
	}

	@Overwrite
	public void add(Recipe<?> p_12701_) {
	}

	@Overwrite
	protected void add(ResourceLocation p_12703_) {
	}

	@Overwrite
	public boolean contains(@Nullable Recipe<?> p_12710_) {
		return false;
	}

	@Overwrite
	public boolean contains(ResourceLocation p_12712_) {
		return false;
	}

	@Overwrite
	public void remove(Recipe<?> p_12714_) {
	}

	@Overwrite
	protected void remove(ResourceLocation p_12716_) {
	}

	@Overwrite
	public boolean willHighlight(Recipe<?> p_12718_) {
		return false;
	}

	@Overwrite
	public void removeHighlight(Recipe<?> p_12722_) {
	}

	@Overwrite
	public void addHighlight(Recipe<?> p_12724_) {
	}

	@Overwrite
	protected void addHighlight(ResourceLocation p_12720_) {
	}

	@Overwrite
	public boolean isOpen(RecipeBookType p_12692_) {
		return false;
	}

	@Overwrite
	public void setOpen(RecipeBookType p_12694_, boolean p_12695_) {
	}

	@Overwrite
	public boolean isFiltering(RecipeBookMenu<?> p_12690_) {
		return false;
	}

	@Overwrite
	public boolean isFiltering(RecipeBookType p_12705_) {
		return false;
	}

	@Overwrite
	public void setFiltering(RecipeBookType p_12707_, boolean p_12708_) {
	}

	@Overwrite
	public void setBookSettings(RecipeBookSettings p_12688_) {
	}

	@Overwrite
	public RecipeBookSettings getBookSettings() {
		return this.bookSettings.copy();
	}

	@Overwrite
	public void setBookSetting(RecipeBookType p_12697_, boolean p_12698_, boolean p_12699_) {
	}
}
