package dev.pfaff.recipe_nope.mixin;

import net.minecraft.client.ClientRecipeBook;
import net.minecraft.client.RecipeBookCategories;
import net.minecraft.client.gui.screens.recipebook.RecipeCollection;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeType;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;

import java.util.List;
import java.util.Map;

@Mixin(ClientRecipeBook.class)
public abstract class ClientRecipeBookMixin {
	@Overwrite
	public void setupCollections(Iterable<Recipe<?>> p_90626_) {
	}

	@Overwrite
	private static Map<RecipeBookCategories, List<List<Recipe<?>>>> categorizeAndGroupRecipes(Iterable<Recipe<?>> p_90643_) {
		return Map.of();
	}

	@Overwrite
	private static RecipeBookCategories getCategory(Recipe<?> p_90647_) {
		return RecipeBookCategories.UNKNOWN;
	}

	@Overwrite
	public List<RecipeCollection> getCollections() {
		return List.of();
	}

	@Overwrite
	public List<RecipeCollection> getCollection(RecipeBookCategories p_90624_) {
		return List.of();
	}

	@Overwrite
	private static Object lambda$getCategory$5(Recipe par1) {
		return RecipeType.CRAFTING;
	}
}
