package dev.pfaff.recipe_nope.mixin;

import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.ListTag;
import net.minecraft.network.protocol.game.ClientboundRecipePacket;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.stats.ServerRecipeBook;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeManager;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;

import java.util.Collection;
import java.util.List;
import java.util.function.Consumer;

@Mixin(ServerRecipeBook.class)
public abstract class ServerRecipeBookMixin {
	@Overwrite
	public int addRecipes(Collection<Recipe<?>> p_12792_, ServerPlayer p_12793_) {
		return 0;
	}

	@Overwrite
	public int removeRecipes(Collection<Recipe<?>> p_12807_, ServerPlayer p_12808_) {
		return 0;
	}

	@Overwrite
	private void sendRecipes(ClientboundRecipePacket.State p_12802_,
							 ServerPlayer p_12803_,
							 List<ResourceLocation> p_12804_) {
	}

	@Overwrite
	public CompoundTag toNbt() {
		return new CompoundTag();
	}

	@Overwrite
	public void fromNbt(CompoundTag p_12795_, RecipeManager p_12796_) {
	}

	@Overwrite
	private void loadRecipes(ListTag p_12798_, Consumer<Recipe<?>> p_12799_, RecipeManager p_12800_) {
	}

	@Overwrite
	public void sendInitialRecipeBook(ServerPlayer p_12790_) {
	}
}
